const startColumn = [
  {
    title: "单位",
    prop: "orgname"
  },
  {
    title: "设备设施名称",
    prop: "name"
  },
  {
    title: "设备设施类型",
    prop: "sblx",
    slot: true
  }
]

const endColumn = [
  {
    title: "生产厂家",
    prop: "sccj"
  },
  {
    title: "投入使用日期",
    prop: "trsysj"
  },
  {
    title: "所属现场部位",
    prop: "sitename"
  },
  {
    title: "安装位置",
    prop: "installlocation"
  },
  {
    title: "状态",
    prop: "state",
    slot: true
  },
  {
    title: "责任人",
    prop: "responsibilitypersonname"
  },
  {
    title: "责任部门",
    prop: "responsibilitydeptname"
  },
]
// 变配电设备设施-高压配电柜、低压配电柜
const common1 = [
  {
    title: "品牌型号",
    prop: "brandModel"
  }
]

export default [
  {
    name: "高压配电柜",
    index: true,
    title: "高压配电柜台账",
    column: [
      ...startColumn,
      ...common1,
      ...endColumn
    ],
    data: []
  },
  {
    name: "低压配电柜",
    index: true,
    title: "低压配电柜台账",
    column: [
      ...startColumn,
      ...common1,
      ...endColumn
    ],
    data: []
  },
  {
    name: "变压器",
    index: true,
    title: "变压器台账",
    column: [
      ...startColumn,
      ...[
        {
          title: "类型",
          prop: "type",
          slot: true
        },
        {
          title: "容量(KvA)",
          prop: "capacity"
        }
      ],
      ...endColumn
    ],
    data: []
  },
  {
    name: "发电机",
    index: true,
    title: "发电机台账",
    column: [
      ...startColumn,
      ...[
        {
          title: "功率(千瓦)",
          prop: "power"
        }
      ],
      ...endColumn
    ],
    data: []
  },
  {
    name: "配电箱（柜、板）",
    index: true,
    title: "配电箱（柜、板）台账",
    column: [
      ...startColumn,
      ...common1,
      ...endColumn
    ],
    data: []
  },
  {
    name: "UPS电源",
    index: true,
    title: "UPS电源台账",
    column: [
      ...startColumn,
      ...[
        {
          title: "视在功率(VA)",
          prop: "apparentPower"
        },
        {
          title: "有功功率(W)",
          prop: "activePower"
        }
      ],
      ...endColumn
    ],
    data: []
  },

]
